/*
** http.h - part of GrabURL 2.0
** Copyright (C) 1996-97 Serge Emond
**
** This program is free software; you can redistribute it and/or
** modify it under the terms of the GNU General Public License
** as published by the Free Software Foundation; either version 2
** of the License, or (at your option) any later version.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#ifndef HTTP_H
#define HTTP_H 1

#include <netdb.h>
#include <netinet/in.h>
#include "graburl.h"

struct HTTP_Head_Line {
  struct HTTP_Head_Line *next;
  char *line;
};

#define FILENAME_ONLY (grab->suri->filename ? grab->suri->filename : "")

extern struct HTTP_Head_Line *http_head;

void HTTP_PostConfig(void);
int GetHTTPFile(struct Grab *, struct URI *, char *);
int lookup(struct sockaddr_in *, const char *, int);
int HTTP_connect(struct Grab *);
int HTTP_sendreq(struct Grab *);
int HTTP_gethead(struct Grab *);
int HTTP_getbody(struct Grab *);
struct HTTP_Head_Line *HTTP_AddHeadLine(char *);
void HTTP_ClearHeadLines(void);
char *HTTP_FindHeadLine(char *);

#define HTTP_PostGetFile(grab) { HTTP_ClearHeadLines(); FreeSURI(grab->suri); \
                                 if (grab->sock) \
                                 { close(grab->sock); grab->sock = 0; } }

#endif
